<html>
<head>
<title>OgreRenderQueueInvocation.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderQueueInvocation.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderQueueInvocation_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment"> Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderQueueInvocation_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueueInvocation_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueueSortingGrouping_8h.html">OgreRenderQueueSortingGrouping.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00066"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html">00066</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00067"></a>00067     {
<a name="l00068"></a>00068     <span class="keyword">protected</span>:
<a name="l00070"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a9d62e3b89ff7a4c8788e6acfee402184">00070</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a9d62e3b89ff7a4c8788e6acfee402184" title="Target queue group.">mRenderQueueGroupID</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a25a715bb1dac5418611625a26ea09c72">00072</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a25a715bb1dac5418611625a26ea09c72" title="Invocation identifier - used in listeners.">mInvocationName</a>;
<a name="l00074"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a96cbe4914fdc8bb421f8b62aff7a4c54">00074</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a96cbe4914fdc8bb421f8b62aff7a4c54" title="Solids ordering mode.">mSolidsOrganisation</a>;
<a name="l00076"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a4eac5c298760a11cfe64daf860e638df">00076</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a4eac5c298760a11cfe64daf860e638df" title="Suppress shadows processing in this invocation?">mSuppressShadows</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae262d7e8f6e75227b83bc816b1327fda">00078</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae262d7e8f6e75227b83bc816b1327fda" title="Suppress OGRE&#39;s render state management?">mSuppressRenderStateChanges</a>;
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> renderQueueGroupID, 
<a name="l00086"></a>00086             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocationName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00087"></a>00087         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>();
<a name="l00088"></a>00088 
<a name="l00090"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae4fa00491fa5cf3bebfc7816240f4418">00090</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae4fa00491fa5cf3bebfc7816240f4418" title="Get the render queue group id.">getRenderQueueGroupID</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRenderQueueGroupID; }
<a name="l00091"></a>00091 
<a name="l00093"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a9661bf4bc551c597918ffd3b87b2826e">00093</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a9661bf4bc551c597918ffd3b87b2826e" title="Get the invocation name (may be blank if not set by creator)">getInvocationName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInvocationName; }
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a6a37071d01a609e279081a906a856dc1">00098</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSolidsOrganisation(
<a name="l00099"></a>00099             <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> org)  
<a name="l00100"></a>00100         { mSolidsOrganisation = org; }
<a name="l00101"></a>00101 
<a name="l00105"></a>00105         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#ab44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a>
<a name="l00106"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae7a631496cc38bd768569605b5dba3c5">00106</a>             <a class="code" href="classOgre_1_1RenderQueueInvocation.html#ae7a631496cc38bd768569605b5dba3c5" title="Get the organisation mode being used for solids in this queue group invocation.">getSolidsOrganisation</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSolidsOrganisation; }
<a name="l00107"></a>00107 
<a name="l00113"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#abc2c82b2c2d72aede9a6a560235e7c27">00113</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSuppressShadows(<span class="keywordtype">bool</span> suppress) 
<a name="l00114"></a>00114         { mSuppressShadows =  suppress; }
<a name="l00115"></a>00115 
<a name="l00118"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a878fae20bf95f1dff6e4de60340df620">00118</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a878fae20bf95f1dff6e4de60340df620" title="Gets whether shadows are suppressed when invoking this queue.">getSuppressShadows</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuppressShadows; }
<a name="l00119"></a>00119 
<a name="l00140"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a4d3821747ee0588c65bfc48982c7e37b">00140</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSuppressRenderStateChanges(<span class="keywordtype">bool</span> suppress) 
<a name="l00141"></a>00141         { mSuppressRenderStateChanges =  suppress; }
<a name="l00142"></a>00142 
<a name="l00145"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#aad7b785b1150206ad5adc732d4e7e7cf">00145</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#aad7b785b1150206ad5adc732d4e7e7cf" title="Gets whether shadows are suppressed when invoking this queue.">getSuppressRenderStateChanges</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuppressRenderStateChanges; }
<a name="l00146"></a>00146 
<a name="l00152"></a>00152         <span class="keyword">virtual</span> <span class="keywordtype">void</span> invoke(<a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* group, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* targetSceneManager);
<a name="l00153"></a>00153 
<a name="l00155"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#a27d41c4a90547ca4a976ac88c53fa3e6">00155</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html#a27d41c4a90547ca4a976ac88c53fa3e6" title="Invocation identifier for shadows.">RENDER_QUEUE_INVOCATION_SHADOWS</a>;
<a name="l00156"></a>00156     };
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00160"></a><a class="code" href="group__RenderSystem.html#ga37ac4666f9eb60576973a7ac8a726b55">00160</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderQueueInvocation*&gt;::type</a> <a class="code" href="group__RenderSystem.html#ga37ac4666f9eb60576973a7ac8a726b55" title="List of RenderQueueInvocations.">RenderQueueInvocationList</a>;
<a name="l00161"></a><a class="code" href="group__RenderSystem.html#gace1177231e9c350bbf4d9862f189b13e">00161</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;RenderQueueInvocationList&gt;</a> <a class="code" href="group__RenderSystem.html#gace1177231e9c350bbf4d9862f189b13e">RenderQueueInvocationIterator</a>;
<a name="l00162"></a>00162 
<a name="l00173"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html">00173</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175     <span class="keyword">protected</span>:
<a name="l00176"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#a7a61d04ea84f2ded758094702c7648a0">00176</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#a7a61d04ea84f2ded758094702c7648a0">mName</a>;
<a name="l00177"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#ae567ddc2821336b54441e83f550cc74f">00177</a>         <a class="code" href="group__RenderSystem.html#ga37ac4666f9eb60576973a7ac8a726b55" title="List of RenderQueueInvocations.">RenderQueueInvocationList</a> <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#ae567ddc2821336b54441e83f550cc74f">mInvocations</a>;
<a name="l00178"></a>00178     <span class="keyword">public</span>:
<a name="l00179"></a>00179         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00180"></a>00180         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>();
<a name="l00181"></a>00181 
<a name="l00183"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#a2077bfd191b704ccbf207056ac3551d3">00183</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#a2077bfd191b704ccbf207056ac3551d3" title="Get the name of this sequence.">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00184"></a>00184 
<a name="l00191"></a>00191         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* add(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> renderQueueGroupID, 
<a name="l00192"></a>00192             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocationName);
<a name="l00193"></a>00193 
<a name="l00200"></a>00200         <span class="keywordtype">void</span> add(<a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* i);
<a name="l00201"></a>00201 
<a name="l00203"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#addf91fd804baf0b2d03dab38c6ebc105">00203</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#addf91fd804baf0b2d03dab38c6ebc105" title="Get the number of invocations in this sequence.">size</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInvocations.size(); }
<a name="l00204"></a>00204 
<a name="l00206"></a>00206         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00207"></a>00207 
<a name="l00209"></a>00209         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* <span class="keyword">get</span>(<span class="keywordtype">size_t</span> index);
<a name="l00210"></a>00210 
<a name="l00212"></a>00212         <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keywordtype">size_t</span> index);
<a name="l00213"></a>00213 
<a name="l00215"></a>00215         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">RenderQueueInvocationIterator</a> iterator(<span class="keywordtype">void</span>);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     };
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#endif</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
